/*
  $Id: addtolist.c,v 1.1.1.1 2001/03/09 12:15:29 rmiya Exp $

  Calculate Molecular Weight and 
    Elemental Analysis

  copyright (c) by Ryo MIYAMOTO, 1998-1999
*/

#include "molwt.h"

void addtolist(float *atoms, char token[][TokenLength], int ntoken)
{
  int i;
  double values;
#ifdef GTK
  gchar str[BUFSIZ];
  gchar *xmstr[1];

  xmstr[0]=(gchar *)malloc(sizeof(gchar)*(BUFSIZ));
#else
  char str[BUFSIZ];
  XmString *xmstr;

  xmstr=(XmString *)XtMalloc(sizeof(XmString)*(NoOfElements+1));
#endif
  for (i=1; i<=NoOfElements; i++) {
    if (atoms[element[i].AtomNo]==0) continue;
    values=100*element[i].Weight * atoms[element[i].AtomNo]/FormulaWeight;
    sprintf(str, "%-3.2s %2g  %10.6f %%", 
            element[i].Symbol, atoms[element[i].AtomNo], values);
#ifdef GTK
    strcpy(xmstr[0], str);
    /*fprintf(stderr, "I'm HERE ! (3):%s:%s:\n", xmstr[0], str);*/
    gtk_clist_insert(GTK_CLIST(resultwin), 0, xmstr);
#else
    xmstr[i]=XmStringCreateLtoR(str, XmFONTLIST_DEFAULT_TAG);
    XmListAddItem(resultwin, xmstr[i], 1);
#endif
  }

}
