/*
  $Id: calculate.c,v 1.4 2001/03/12 13:22:43 rmiya Exp $

  Calculate Molecular Weight and 
    Elemental Analysis

  copyright (c) by Ryo MIYAMOTO, 1998-1999
*/

#include "molwt.h"

#ifdef GTK
void calculateCB(GtkWidget *w, gpointer callData)
#else
void calculateCB(Widget w, XtPointer clientData, XtPointer callData)
#endif
{
  int i;
  char str[BUFSIZ];

  for (i=1; i<=NoOfElements; i++) 
    atoms[i] = 0;

  ntoken = reduce(token, inputstr); 
  count(atoms, token, ntoken);

  FormulaWeight=0;
  for (i=1; i<=NoOfElements; i++) {
    FormulaWeight += element[i].Weight * atoms[element[i].AtomNo];
  }
  sprintf(str, "%f", FormulaWeight);
  /*fprintf(stderr, "%f\n", FormulaWeight);*/
#ifdef GTK
  gtk_entry_set_text(GTK_ENTRY(weightwin), str);
#else
  XmTextFieldSetString(weightwin, str);
#endif

  /*fprintf(stderr, "I'm HERE ! (1)\n");*/
  addtolist(atoms, token, ntoken);
  /*fprintf(stderr, "I'm HERE ! (2)\n");*/

#ifdef GTK
  gtk_widget_grab_focus(inputline);
#else
  XmProcessTraversal(inputline, XmTRAVERSE_CURRENT);
#endif
}

void calculate2(void)
{
  int i;
  char str[BUFSIZ];
  double values;

  FormulaWeight=0;
  for (i=1; i<=NoOfElements; i++) {
    FormulaWeight += element[i].Weight * atoms[element[i].AtomNo];
  }
  sprintf(str, "Formula Weight = %f", FormulaWeight);
  puts(str);

  for (i=NoOfElements; i>=1; --i) {
    if (atoms[element[i].AtomNo]==0) continue;
    values=100*element[i].Weight * atoms[element[i].AtomNo]/FormulaWeight;
    sprintf(str, "%-3.2s %2g  %10.6f %%", 
            element[i].Symbol, atoms[element[i].AtomNo], values);
    puts(str);
  }
}
