/*
  $Id: count.c,v 1.5 2001/11/30 06:20:16 rmiya Exp $

  Calculate Molecular Weight and 
    Elemental Analysis

  copyright (c) by Ryo MIYAMOTO, 1998-2001
*/

#include "molwt.h"

int count(float *atoms, char token[NoOfToken][TokenLength], int ntoken)
{
  int nbraket=0, i, j, n, k, i0;
  float num, times;
  char buf[BUFSIZ], *str2;

  for (i=0; i<ntoken; i++) {
/*    fprintf(stderr, ">%d %s\n", i, token[i]);*/
    if (isalpha(token[i][0])) {
      if ((atomicnumber(token[i], Symbol2, &n)) != -1) {
/*        fprintf(stderr, "atomic number = %d, ", element[n].AtomNo);*/
	num=strtod(token[++i], &str2);
	if (strlen(token[i]) != (int)(str2-token[i])) {
	  errorDialog(isGUI);
	  break;
	}
/*        fprintf(stderr, "%p %p %d\n", token[i], str2, (int)(str2-token[i]));*/
/*        fprintf(stderr, "no. of atoms = %g\n", num);*/
        atoms[element[n].AtomNo]+=num;
      } else {
	errorDialog(isGUI);
	break;
      }
    } else if (token[i][0] == '(') {
      nbraket++;
/*      fprintf(stderr, "braket ( %d\n", nbraket);*/
    } else if (token[i][0] == ')') {
      times=strtod(token[++i], &str2);
      if (strlen(token[i]) != (int)(str2-token[i])) {
        errorDialog(isGUI);
	break;
      }
/*      fprintf(stderr, "braket ) %d * %g\n", nbraket, times);*/
      if ((--nbraket) < 0) {
	errorDialog(isGUI);
	break;
      }
      
      j = i;
      while (token[j][0] != '(') {
        if (isalpha(token[j][0])) {
	  atomicnumber(token[j], Symbol2, &n);
          num=strtod(token[j+1], &str2);
          atoms[element[n].AtomNo] += num*(times-1);
	  sprintf(buf, "%g", num*times);
	  strcpy(token[j+1], buf);
	} else if (isdigit(token[j][0]) || token[j][0]=='.') {
	}
        --j;
      }
      for (k = j; k < ntoken - 1; k++) {
	strcpy(token[k], token[k + 1]); /* ( */
      }
      strcpy(token[--ntoken], " ");
      --i;
      for (k = i; k < ntoken - 1; k++) {
	strcpy(token[k - 1], token[k + 1]); /* ), number */
      }
      strcpy(token[--ntoken], " ");
      strcpy(token[--ntoken], " ");
      i -= 2;

/*      for (i0=0; i0<ntoken; i0++)
	fprintf(stderr, "%s:", token[i0]);
      fputs("\n", stderr); */

    } else  if (token[i][0] == ' ') {
      ; /* do nothing */
    } else {
      errorDialog(isGUI);
      break;
    }
  }
  if (nbraket>0) {
    errorDialog(isGUI);
  }

  return i;
}
