/*
  $Id: element.c,v 1.3 2001/08/22 03:43:41 rmiya Exp $

  Calculate Molecular Weight and 
    Elemental Analysis

  copyright (c) by Ryo MIYAMOTO, 1998-2001
*/

#include "molwt.h"

/* 
  Atomic Weight is recommended by IUPAC 1999.
  Atomic Symbol is written in CAPITAL LETTER.
 */

void elements()
{
  int i, j;
  struct Element temp;

  element[  1].AtomNo = 1;
  element[  1].Weight = 1.00794;
  element[  1].Symbol = "H";
  element[  1].Symbol2 = "h";
  element[  1].Name = "Hydrogen";

  element[  2].AtomNo = 2;
  element[  2].Weight = 4.002602;
  element[  2].Symbol = "He";
  element[  2].Symbol2 = "he";
  element[  2].Name = "Helium";

  element[  3].AtomNo = 3;
  element[  3].Weight = 6.941;
  element[  3].Symbol = "Li";
  element[  3].Symbol2 = "li";
  element[  3].Name = "Lithium";

  element[  4].AtomNo = 4;
  element[  4].Weight = 9.012182;
  element[  4].Symbol = "Be";
  element[  4].Symbol2 = "be";
  element[  4].Name = "Beryllium";

  element[  5].AtomNo = 5;
  element[  5].Weight = 10.811;
  element[  5].Symbol = "B";
  element[  5].Symbol2 = "b";
  element[  5].Name = "Boron";

  element[  6].AtomNo = 6;
  element[  6].Weight = 12.0107;
  element[  6].Symbol = "C";
  element[  6].Symbol2 = "c";
  element[  6].Name = "Carbon";

  element[  7].AtomNo = 7;
  element[  7].Weight = 14.0067;
  element[  7].Symbol = "N";
  element[  7].Symbol2 = "n";
  element[  7].Name = "Nitrogen";

  element[  8].AtomNo = 8;
  element[  8].Weight = 15.9994;
  element[  8].Symbol = "O";
  element[  8].Symbol2 = "o";
  element[  8].Name = "Oxygen";

  element[  9].AtomNo = 9;
  element[  9].Weight = 18.9984032;
  element[  9].Symbol = "F";
  element[  9].Symbol2 = "f";
  element[  9].Name = "Fluorine";

  element[ 10].AtomNo = 10;
  element[ 10].Weight = 20.1797;
  element[ 10].Symbol = "Ne";
  element[ 10].Symbol2 = "ne";
  element[ 10].Name = "Neon";

  element[ 11].AtomNo = 11;
  element[ 11].Weight = 22.989770;
  element[ 11].Symbol = "Na";
  element[ 11].Symbol2 = "na";
  element[ 11].Name = "Sodium";

  element[ 12].AtomNo = 12;
  element[ 12].Weight = 24.3050;
  element[ 12].Symbol = "Mg";
  element[ 12].Symbol2 = "mg";
  element[ 12].Name = "Magnesium";

  element[ 13].AtomNo = 13;
  element[ 13].Weight = 26.981538;
  element[ 13].Symbol = "Al";
  element[ 13].Symbol2 = "al";
  element[ 13].Name = "Aluminium";

  element[ 14].AtomNo = 14;
  element[ 14].Weight = 28.0855;
  element[ 14].Symbol = "Si";
  element[ 14].Symbol2 = "si";
  element[ 14].Name = "Silicon";

  element[ 15].AtomNo = 15;
  element[ 15].Weight = 30.973761;
  element[ 15].Symbol = "P";
  element[ 15].Symbol2 = "p";
  element[ 15].Name = "Phosphorus";

  element[ 16].AtomNo = 16;
  element[ 16].Weight = 32.065;
  element[ 16].Symbol = "S";
  element[ 16].Symbol2 = "s";
  element[ 16].Name = "Sulfur";

  element[ 17].AtomNo = 17;
  element[ 17].Weight = 35.453;
  element[ 17].Symbol = "Cl";
  element[ 17].Symbol2 = "cl";
  element[ 17].Name = "Chlorine";

  element[ 18].AtomNo = 18;
  element[ 18].Weight = 39.948;
  element[ 18].Symbol = "Ar";
  element[ 18].Symbol2 = "ar";
  element[ 18].Name = "Argon";

  element[ 19].AtomNo = 19;
  element[ 19].Weight = 39.0983;
  element[ 19].Symbol = "K";
  element[ 19].Symbol2 = "k";
  element[ 19].Name = "Potassium";

  element[ 20].AtomNo = 20;
  element[ 20].Weight = 40.078;
  element[ 20].Symbol = "Ca";
  element[ 20].Symbol2 = "ca";
  element[ 20].Name = "Calcium";

  element[ 21].AtomNo = 21;
  element[ 21].Weight = 44.955910;
  element[ 21].Symbol = "Sc";
  element[ 21].Symbol2 = "sc";
  element[ 21].Name = "Scandium";

  element[ 22].AtomNo = 22;
  element[ 22].Weight = 47.867;
  element[ 22].Symbol = "Ti";
  element[ 22].Symbol2 = "ti";
  element[ 22].Name = "Titanium";

  element[ 23].AtomNo = 23;
  element[ 23].Weight = 50.9415;
  element[ 23].Symbol = "V";
  element[ 23].Symbol2 = "v";
  element[ 23].Name = "Vanadium";

  element[ 24].AtomNo = 24;
  element[ 24].Weight = 51.9961;
  element[ 24].Symbol = "Cr";
  element[ 24].Symbol2 = "cr";
  element[ 24].Name = "Chromium";

  element[ 25].AtomNo = 25;
  element[ 25].Weight = 54.938049;
  element[ 25].Symbol = "Mn";
  element[ 25].Symbol2 = "mn";
  element[ 25].Name = "Manganese";

  element[ 26].AtomNo = 26;
  element[ 26].Weight = 55.845;
  element[ 26].Symbol = "Fe";
  element[ 26].Symbol2 = "fe";
  element[ 26].Name = "Iron";

  element[ 27].AtomNo = 27;
  element[ 27].Weight = 58.933200;
  element[ 27].Symbol = "Co";
  element[ 27].Symbol2 = "co";
  element[ 27].Name = "Cobalt";

  element[ 28].AtomNo = 28;
  element[ 28].Weight = 58.6934;
  element[ 28].Symbol = "Ni";
  element[ 28].Symbol2 = "ni";
  element[ 28].Name = "Nickel";

  element[ 29].AtomNo = 29;
  element[ 29].Weight = 63.546;
  element[ 29].Symbol = "Cu";
  element[ 29].Symbol2 = "cu";
  element[ 29].Name = "Copper";

  element[ 30].AtomNo = 30;
  element[ 30].Weight = 65.39;
  element[ 30].Symbol = "Zn";
  element[ 30].Symbol2 = "zn";
  element[ 30].Name = "Zinc";

  element[ 31].AtomNo = 31;
  element[ 31].Weight = 69.723;
  element[ 31].Symbol = "Ga";
  element[ 31].Symbol2 = "ga";
  element[ 31].Name = "Gallium";

  element[ 32].AtomNo = 32;
  element[ 32].Weight = 72.64;
  element[ 32].Symbol = "Ge";
  element[ 32].Symbol2 = "ge";
  element[ 32].Name = "Germanium";

  element[ 33].AtomNo = 33;
  element[ 33].Weight = 74.92160;
  element[ 33].Symbol = "As";
  element[ 33].Symbol2 = "as";
  element[ 33].Name = "Arsenic";

  element[ 34].AtomNo = 34;
  element[ 34].Weight = 78.96;
  element[ 34].Symbol = "Se";
  element[ 34].Symbol2 = "se";
  element[ 34].Name = "Selenium";

  element[ 35].AtomNo = 35;
  element[ 35].Weight = 79.904;
  element[ 35].Symbol = "Br";
  element[ 35].Symbol2 = "br";
  element[ 35].Name = "Bromine";

  element[ 36].AtomNo = 36;
  element[ 36].Weight = 83.80;
  element[ 36].Symbol = "Kr";
  element[ 36].Symbol2 = "kr";
  element[ 36].Name = "Krypton";

  element[ 37].AtomNo = 37;
  element[ 37].Weight = 85.4678;
  element[ 37].Symbol = "Rb";
  element[ 37].Symbol2 = "rb";
  element[ 37].Name = "Rubidium";

  element[ 38].AtomNo = 38;
  element[ 38].Weight = 87.62;
  element[ 38].Symbol = "Sr";
  element[ 38].Symbol2 = "sr";
  element[ 38].Name = "Strontium";

  element[ 39].AtomNo = 39;
  element[ 39].Weight = 88.90585;
  element[ 39].Symbol = "Y";
  element[ 39].Symbol2 = "y";
  element[ 39].Name = "Yttrium";

  element[ 40].AtomNo = 40;
  element[ 40].Weight = 91.224;
  element[ 40].Symbol = "Zr";
  element[ 40].Symbol2 = "zr";
  element[ 40].Name = "Zirconium";

  element[ 41].AtomNo = 41;
  element[ 41].Weight = 92.90638;
  element[ 41].Symbol = "Nb";
  element[ 41].Symbol2 = "nb";
  element[ 41].Name = "Niobium";

  element[ 42].AtomNo = 42;
  element[ 42].Weight = 95.94;
  element[ 42].Symbol = "Mo";
  element[ 42].Symbol2 = "mo";
  element[ 42].Name = "Molybdenum";

  element[ 43].AtomNo = 43;
  element[ 43].Weight = 99;
  element[ 43].Symbol = "Tc";
  element[ 43].Symbol2 = "tc";
  element[ 43].Name = "Technetium";

  element[ 44].AtomNo = 44;
  element[ 44].Weight = 101.07;
  element[ 44].Symbol = "Ru";
  element[ 44].Symbol2 = "ru";
  element[ 44].Name = "Ruthenium";

  element[ 45].AtomNo = 45;
  element[ 45].Weight = 102.90550;
  element[ 45].Symbol = "Rh";
  element[ 45].Symbol2 = "rh";
  element[ 45].Name = "Rhodium";

  element[ 46].AtomNo = 46;
  element[ 46].Weight = 106.42;
  element[ 46].Symbol = "Pd";
  element[ 46].Symbol2 = "pd";
  element[ 46].Name = "Palladium";

  element[ 47].AtomNo = 47;
  element[ 47].Weight = 107.8682;
  element[ 47].Symbol = "Ag";
  element[ 47].Symbol2 = "ag";
  element[ 47].Name = "Silver";

  element[ 48].AtomNo = 48;
  element[ 48].Weight = 112.411;
  element[ 48].Symbol = "Cd";
  element[ 48].Symbol2 = "cd";
  element[ 48].Name = "Cadmium";

  element[ 49].AtomNo = 49;
  element[ 49].Weight = 114.818;
  element[ 49].Symbol = "In";
  element[ 49].Symbol2 = "in";
  element[ 49].Name = "Indium";

  element[ 50].AtomNo = 50;
  element[ 50].Weight = 118.710;
  element[ 50].Symbol = "Sn";
  element[ 50].Symbol2 = "sn";
  element[ 50].Name = "Tin";

  element[ 51].AtomNo = 51;
  element[ 51].Weight = 121.760;
  element[ 51].Symbol = "Sb";
  element[ 51].Symbol2 = "sb";
  element[ 51].Name = "Antimony";

  element[ 52].AtomNo = 52;
  element[ 52].Weight = 127.60;
  element[ 52].Symbol = "Te";
  element[ 52].Symbol2 = "te";
  element[ 52].Name = "Tellurium";

  element[ 53].AtomNo = 53;
  element[ 53].Weight = 126.90447;
  element[ 53].Symbol = "I";
  element[ 53].Symbol2 = "i";
  element[ 53].Name = "Iodine";

  element[ 54].AtomNo = 54;
  element[ 54].Weight = 131.293;
  element[ 54].Symbol = "Xe";
  element[ 54].Symbol2 = "xe";
  element[ 54].Name = "Xenon";

  element[ 55].AtomNo = 55;
  element[ 55].Weight = 132.90545;
  element[ 55].Symbol = "Cs";
  element[ 55].Symbol2 = "cs";
  element[ 55].Name = "Caesium";

  element[ 56].AtomNo = 56;
  element[ 56].Weight = 137.327;
  element[ 56].Symbol = "Ba";
  element[ 56].Symbol2 = "ba";
  element[ 56].Name = "Barium";

  element[ 57].AtomNo = 57;
  element[ 57].Weight = 138.9055;
  element[ 57].Symbol = "La";
  element[ 57].Symbol2 = "la";
  element[ 57].Name = "Lanthanum";

  element[ 58].AtomNo = 58;
  element[ 58].Weight = 140.116;
  element[ 58].Symbol = "Ce";
  element[ 58].Symbol2 = "ce";
  element[ 58].Name = "Cerium";

  element[ 59].AtomNo = 59;
  element[ 59].Weight = 140.90765;
  element[ 59].Symbol = "Pr";
  element[ 59].Symbol2 = "pr";
  element[ 59].Name = "Praseodymium";

  element[ 60].AtomNo = 60;
  element[ 60].Weight = 144.24;
  element[ 60].Symbol = "Nd";
  element[ 60].Symbol2 = "nd";
  element[ 60].Name = "Neodymium";

  element[ 61].AtomNo = 61;
  element[ 61].Weight = 145;
  element[ 61].Symbol = "Pm";
  element[ 61].Symbol2 = "pm";
  element[ 61].Name = "Promethium";

  element[ 62].AtomNo = 62;
  element[ 62].Weight = 150.36;
  element[ 62].Symbol = "Sm";
  element[ 62].Symbol2 = "sm";
  element[ 62].Name = "Samarium";

  element[ 63].AtomNo = 63;
  element[ 63].Weight = 151.964;
  element[ 63].Symbol = "Eu";
  element[ 63].Symbol2 = "eu";
  element[ 63].Name = "Europium";

  element[ 64].AtomNo = 64;
  element[ 64].Weight = 157.25;
  element[ 64].Symbol = "Gd";
  element[ 64].Symbol2 = "gd";
  element[ 64].Name = "Gadolinium";

  element[ 65].AtomNo = 65;
  element[ 65].Weight = 158.92534;
  element[ 65].Symbol = "Tb";
  element[ 65].Symbol2 = "tb";
  element[ 65].Name = "Terbium";

  element[ 66].AtomNo = 66;
  element[ 66].Weight = 162.50;
  element[ 66].Symbol = "Dy";
  element[ 66].Symbol2 = "dy";
  element[ 66].Name = "Dysprosium";

  element[ 67].AtomNo = 67;
  element[ 67].Weight = 164.93032;
  element[ 67].Symbol = "Ho";
  element[ 67].Symbol2 = "ho";
  element[ 67].Name = "Holmium";

  element[ 68].AtomNo = 68;
  element[ 68].Weight = 167.259;
  element[ 68].Symbol = "Er";
  element[ 68].Symbol2 = "er";
  element[ 68].Name = "Erbium";

  element[ 69].AtomNo = 69;
  element[ 69].Weight = 168.93421;
  element[ 69].Symbol = "Tm";
  element[ 69].Symbol2 = "tm";
  element[ 69].Name = "Thulium";

  element[ 70].AtomNo = 70;
  element[ 70].Weight = 173.04;
  element[ 70].Symbol = "Yb";
  element[ 70].Symbol2 = "yb";
  element[ 70].Name = "Ytterbium";

  element[ 71].AtomNo = 71;
  element[ 71].Weight = 174.967;
  element[ 71].Symbol = "Lu";
  element[ 71].Symbol2 = "lu";
  element[ 71].Name = "Lutetium";

  element[ 72].AtomNo = 72;
  element[ 72].Weight = 178.49;
  element[ 72].Symbol = "Hf";
  element[ 72].Symbol2 = "hf";
  element[ 72].Name = "Hafnium";

  element[ 73].AtomNo = 73;
  element[ 73].Weight = 180.9479;
  element[ 73].Symbol = "Ta";
  element[ 73].Symbol2 = "ta";
  element[ 73].Name = "Tantalum";

  element[ 74].AtomNo = 74;
  element[ 74].Weight = 183.84;
  element[ 74].Symbol = "W";
  element[ 74].Symbol2 = "w";
  element[ 74].Name = "Tungsten";

  element[ 75].AtomNo = 75;
  element[ 75].Weight = 186.207;
  element[ 75].Symbol = "Re";
  element[ 75].Symbol2 = "re";
  element[ 75].Name = "Rhenium";

  element[ 76].AtomNo = 76;
  element[ 76].Weight = 190.23;
  element[ 76].Symbol = "Os";
  element[ 76].Symbol2 = "os";
  element[ 76].Name = "Osmium";

  element[ 77].AtomNo = 77;
  element[ 77].Weight = 192.217;
  element[ 77].Symbol = "Ir";
  element[ 77].Symbol2 = "ir";
  element[ 77].Name = "Iridium";

  element[ 78].AtomNo = 78;
  element[ 78].Weight = 195.078;
  element[ 78].Symbol = "Pt";
  element[ 78].Symbol2 = "pt";
  element[ 78].Name = "Platinum";

  element[ 79].AtomNo = 79;
  element[ 79].Weight = 196.96655;
  element[ 79].Symbol = "Au";
  element[ 79].Symbol2 = "au";
  element[ 79].Name = "Gold";

  element[ 80].AtomNo = 80;
  element[ 80].Weight = 200.59;
  element[ 80].Symbol = "Hg";
  element[ 80].Symbol2 = "hg";
  element[ 80].Name = "Mercury";

  element[ 81].AtomNo = 81;
  element[ 81].Weight = 204.3833;
  element[ 81].Symbol = "Tl";
  element[ 81].Symbol2 = "tl";
  element[ 81].Name = "Thallium";

  element[ 82].AtomNo = 82;
  element[ 82].Weight = 207.2;
  element[ 82].Symbol = "Pb";
  element[ 82].Symbol2 = "pb";
  element[ 82].Name = "Lead";

  element[ 83].AtomNo = 83;
  element[ 83].Weight = 208.98038;
  element[ 83].Symbol = "Bi";
  element[ 83].Symbol2 = "bi";
  element[ 83].Name = "Bismuth";

  element[ 84].AtomNo = 84;
  element[ 84].Weight = 210;
  element[ 84].Symbol = "Po";
  element[ 84].Symbol2 = "po";
  element[ 84].Name = "Polonium";

  element[ 85].AtomNo = 85;
  element[ 85].Weight = 210;
  element[ 85].Symbol = "At";
  element[ 85].Symbol2 = "at";
  element[ 85].Name = "Astatine";

  element[ 86].AtomNo = 86;
  element[ 86].Weight = 222;
  element[ 86].Symbol = "Rn";
  element[ 86].Symbol2 = "rn";
  element[ 86].Name = "Radon";

  element[ 87].AtomNo = 87;
  element[ 87].Weight = 223;
  element[ 87].Symbol = "Fr";
  element[ 87].Symbol2 = "fr";
  element[ 87].Name = "Francium";

  element[ 88].AtomNo = 88;
  element[ 88].Weight = 226;
  element[ 88].Symbol = "Ra";
  element[ 88].Symbol2 = "ra";
  element[ 88].Name = "Radium";

  element[ 89].AtomNo = 89;
  element[ 89].Weight = 227;
  element[ 89].Symbol = "Ac";
  element[ 89].Symbol2 = "ac";
  element[ 89].Name = "Actinium";

  element[ 90].AtomNo = 90;
  element[ 90].Weight = 232.0381;
  element[ 90].Symbol = "Th";
  element[ 90].Symbol2 = "th";
  element[ 90].Name = "Thorium";

  element[ 91].AtomNo = 91;
  element[ 91].Weight = 231.03588;
  element[ 91].Symbol = "Pa";
  element[ 91].Symbol2 = "pa";
  element[ 91].Name = "Protactinium";

  element[ 92].AtomNo = 92;
  element[ 92].Weight = 238.02891;
  element[ 92].Symbol = "U";
  element[ 92].Symbol2 = "u";
  element[ 92].Name = "Uranium";

  element[ 93].AtomNo = 93;
  element[ 93].Weight = 237;
  element[ 93].Symbol = "Np";
  element[ 93].Symbol2 = "np";
  element[ 93].Name = "Neptunium";

  element[ 94].AtomNo = 94;
  element[ 94].Weight = 239;
  element[ 94].Symbol = "Pu";
  element[ 94].Symbol2 = "pu";
  element[ 94].Name = "Plutonium";

  element[ 95].AtomNo = 95;
  element[ 95].Weight = 243;
  element[ 95].Symbol = "Am";
  element[ 95].Symbol2 = "am";
  element[ 95].Name = "Americium";

  element[ 96].AtomNo = 96;
  element[ 96].Weight = 247;
  element[ 96].Symbol = "Cm";
  element[ 96].Symbol2 = "cm";
  element[ 96].Name = "Curium";

  element[ 97].AtomNo = 97;
  element[ 97].Weight = 247;
  element[ 97].Symbol = "Bk";
  element[ 97].Symbol2 = "bk";
  element[ 97].Name = "Berkelium";

  element[ 98].AtomNo = 98;
  element[ 98].Weight = 252;
  element[ 98].Symbol = "Cf";
  element[ 98].Symbol2 = "cf";
  element[ 98].Name = "Californium";

  element[ 99].AtomNo = 99;
  element[ 99].Weight = 252;
  element[ 99].Symbol = "Es";
  element[ 99].Symbol2 = "es";
  element[ 99].Name = "Einsteinium";

  element[100].AtomNo = 100;
  element[100].Weight = 257;
  element[100].Symbol = "Fm";
  element[100].Symbol2 = "fm";
  element[100].Name = "Fermium";

  element[101].AtomNo = 101;
  element[101].Weight = 258;
  element[101].Symbol = "Md";
  element[101].Symbol2 = "md";
  element[101].Name = "Mendelevium";

  element[102].AtomNo = 102;
  element[102].Weight = 259;
  element[102].Symbol = "No";
  element[102].Symbol2 = "no";
  element[102].Name = "Nobelium";

  element[103].AtomNo = 103;
  element[103].Weight = 262;
  element[103].Symbol = "Lr";
  element[103].Symbol2 = "lr";
  element[103].Name = "Lawrencium";

  element[104].AtomNo = 104;
  element[104].Weight = 261;
  element[104].Symbol = "Rf";
  element[104].Symbol2 = "rf";
  element[104].Name = "Rutherfordium";

  element[105].AtomNo = 105;
  element[105].Weight = 262;
  element[105].Symbol = "Db";
  element[105].Symbol2 = "db";
  element[105].Name = "Dubnium";

  element[106].AtomNo = 106;
  element[106].Weight = 263;
  element[106].Symbol = "Sg";
  element[106].Symbol2 = "sg";
  element[106].Name = "Seaborgium";

  element[107].AtomNo = 107;
  element[107].Weight = 264;
  element[107].Symbol = "Bh";
  element[107].Symbol2 = "bh";
  element[107].Name = "Bohrium";

  element[108].AtomNo = 108;
  element[108].Weight = 265;
  element[108].Symbol = "Hs";
  element[108].Symbol2 = "hs";
  element[108].Name = "Hassium";

  element[109].AtomNo = 109;
  element[109].Weight = 268;
  element[109].Symbol = "Mt";
  element[109].Symbol2 = "mt";
  element[109].Name = "Meitnerium";

  /* NoOfElements == 109 */

  /* sort by Atomic Symbol in reverse order */
  for (i=1; i<NoOfElements; i++) 
    for (j=i+1; j<NoOfElements+1; j++)
      if (strcmp(element[i].Symbol, element[j].Symbol) < 0) {
	temp.AtomNo = element[i].AtomNo;
	temp.Weight = element[i].Weight;
	temp.Symbol = element[i].Symbol;
	temp.Symbol2 = element[i].Symbol2;
	temp.Name = element[i].Name;

	element[i].AtomNo = element[j].AtomNo;
	element[i].Weight = element[j].Weight;
	element[i].Symbol = element[j].Symbol;
	element[i].Symbol2 = element[j].Symbol2;
	element[i].Name = element[j].Name;

	element[j].AtomNo = temp.AtomNo;
	element[j].Weight = temp.Weight;
	element[j].Symbol = temp.Symbol;
	element[j].Symbol2 = temp.Symbol2;
	element[j].Name = temp.Name;
      }

/*  for(i=1; i<NoOfElements; i++)
    fprintf(stderr, "%s:", element[i].Symbol);*/
}
