/*
  $Id: initwidget.c,v 1.3 2001/03/12 12:04:23 rmiya Exp $

  Calculate Molecular Weight and 
    Elemental Analysis

  copyright (c) by Ryo MIYAMOTO, 1998-1999
*/

#include "molwt.h"

#ifdef GTK
static void inputdone(GtkWidget *, gpointer);
#else
static void inputdone(Widget, XtPointer, XtPointer);
#endif

int initwidget()
{
#ifdef GTK
  panel=gtk_vbox_new(FALSE, 10);
  gtk_container_add(GTK_CONTAINER(toplevel), panel);
  gtk_container_border_width(GTK_CONTAINER(toplevel), 15);

  labelformula=gtk_label_new("Formula:     ");
  gtk_box_pack_start(GTK_BOX(panel), labelformula, FALSE, FALSE, 0);
  gtk_widget_show(labelformula);
  inputline=gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(panel), inputline, FALSE, FALSE, 0);
  gtk_widget_show(inputline);
  gtk_signal_connect(GTK_OBJECT(inputline), "activate", GTK_SIGNAL_FUNC(inputdone), NULL);

  casebutton=gtk_check_button_new_with_label("Allow LowerCase");
  gtk_box_pack_start(GTK_BOX(panel), casebutton, FALSE, FALSE, 0);
  gtk_widget_show(casebutton);
  Symbol2=GTK_TOGGLE_BUTTON(casebutton)->active;
  gtk_signal_connect(GTK_OBJECT(casebutton), "toggled", GTK_SIGNAL_FUNC(allowcase), NULL);

  buttons=gtk_hbox_new(FALSE, 10);
  calcbutton=gtk_button_new_with_label("Calculate");
  gtk_box_pack_start(GTK_BOX(buttons), calcbutton, TRUE, TRUE, 5);
  gtk_widget_show(calcbutton);
  gtk_signal_connect(GTK_OBJECT(calcbutton), "clicked", GTK_SIGNAL_FUNC(inputformula), NULL);
  gtk_signal_connect(GTK_OBJECT(calcbutton), "clicked", GTK_SIGNAL_FUNC(calculateCB), NULL);

  clearbutton=gtk_button_new_with_label("Clear");
  gtk_box_pack_start(GTK_BOX(buttons), clearbutton, TRUE, TRUE, 5);
  gtk_widget_show(clearbutton);
  gtk_signal_connect(GTK_OBJECT(clearbutton), "clicked", GTK_SIGNAL_FUNC(clearline), NULL);

  endbutton=gtk_button_new_with_label("End");
  gtk_box_pack_start(GTK_BOX(buttons), endbutton, TRUE, TRUE, 5);
  gtk_widget_show(endbutton);
  gtk_signal_connect(GTK_OBJECT(endbutton), "clicked", GTK_SIGNAL_FUNC(endofprogram), NULL);

  gtk_box_pack_start(GTK_BOX(panel), buttons, FALSE, FALSE, 0);
  gtk_widget_show(buttons);

  labelweight=gtk_label_new("Formula Weight:");
  gtk_widget_show(labelweight);
  gtk_box_pack_start(GTK_BOX(panel), labelweight, FALSE, FALSE, 0);
  weightwin=gtk_entry_new();
  gtk_widget_show(weightwin);
  gtk_box_pack_start(GTK_BOX(panel), weightwin, FALSE, FALSE, 0);

  labelcontents=gtk_label_new("Contents:");
  gtk_widget_show(labelcontents);
  gtk_box_pack_start(GTK_BOX(panel), labelcontents, FALSE, FALSE, 0);
  resultwin=gtk_clist_new(1);
  gtk_widget_show(resultwin);
  gtk_box_pack_start(GTK_BOX(panel), resultwin, TRUE, TRUE, 0);

  gtk_widget_show(panel);
  gtk_widget_show(toplevel);
  gtk_signal_connect(GTK_OBJECT(toplevel), "destroy", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
#else
  bb=XmCreateBulletinBoard(toplevel, "bb", NULL, 0);
  XtManageChild(bb);
  panel=XmCreateRowColumn(bb, "panel", NULL, 0);
  XtManageChild(panel);

  labelformula=XmCreateLabel(panel, "labelformula", NULL, 0);
  XtManageChild(labelformula);
  inputline=XmCreateTextField(panel, "inputline", NULL, 0);
  XtManageChild(inputline);
  XtAddCallback(inputline, XmNactivateCallback, inputdone, NULL);
  XmAddTabGroup(inputline);

  casebutton=XmCreateToggleButton(panel, "casebutton", NULL, 0);
  XtManageChild(casebutton);
  Symbol2=XmToggleButtonGetState(casebutton);
  XtAddCallback(casebutton, XmNvalueChangedCallback, allowcase, NULL);
  XmAddTabGroup(casebutton);

  buttons=XmCreateRowColumn(panel, "buttons", NULL, 0);
  XtManageChild(buttons);

  calcbutton=XmCreatePushButton(buttons, "calcbutton", NULL, 0);
  XtManageChild(calcbutton);
  XtAddCallback(calcbutton, XmNactivateCallback, inputformula, NULL);
  XtAddCallback(calcbutton, XmNactivateCallback, calculateCB, NULL);
  XmAddTabGroup(calcbutton);

  clearbutton=XmCreatePushButton(buttons, "clearbutton", NULL, 0);
  XtManageChild(clearbutton);
  XtAddCallback(clearbutton, XmNactivateCallback, clearline, NULL);
  XmAddTabGroup(clearbutton);

  endbutton=XmCreatePushButton(buttons, "endbutton", NULL, 0);
  XtManageChild(endbutton);
  XtAddCallback(endbutton, XmNactivateCallback, endofprogram, NULL);
  XmAddTabGroup(endbutton);

  labelweight=XmCreateLabel(panel, "labelweight", NULL, 0);
  XtManageChild(labelweight);
  weightwin=XmCreateTextField(panel, "weightwin", NULL, 0);
  XtManageChild(weightwin);

  labelcontents=XmCreateLabel(panel, "labelcontents", NULL, 0);
  XtManageChild(labelcontents);
  resultwin=XmCreateScrolledList(panel, "resultwin", NULL, 0);
  XtManageChild(resultwin);


  XtRealizeWidget(toplevel);
#endif
  return 0;
}

#ifdef GTK
static void inputdone(GtkWidget *w, gpointer data)
#else
static void inputdone(Widget w, XtPointer clientData, XtPointer callData)
#endif
{
#ifdef GTK
  inputformula(w, NULL);
  calculateCB(w, NULL);
#else
  inputformula(w, NULL, NULL);
  calculateCB(w, NULL, NULL);
#endif
}
