/*
  $Id: inputformula.c,v 1.5 2001/03/14 05:44:07 rmiya Exp $

  Calculate Molecular Weight and 
    Elemental Analysis

  copyright (c) by Ryo MIYAMOTO, 1998-1999
*/

#include "molwt.h"

#ifdef GTK
void inputformula(GtkWidget *w, gpointer callData)
#else
void inputformula(Widget w, XtPointer clientData, XtPointer callData)
#endif
{
  int i;

#ifdef GTK
  gtk_entry_set_text(GTK_ENTRY(weightwin), "");
  gtk_clist_clear(GTK_CLIST(resultwin));
#else
  XmTextFieldSetString(weightwin, "");
  XtVaSetValues(resultwin, XmNitems, NULL, XmNitemCount, 0, NULL);
#endif
  for(i=0; i<NoOfToken; i++)
    strcpy(token[i], "");
  ntoken=0;

#ifdef GTK
  strcpy(inputstr, gtk_entry_get_text(GTK_ENTRY(inputline)));
#else
  strcpy(inputstr, XmTextFieldGetString(inputline));
#endif
  /*puts(inputstr);*/
}

#ifdef GTK
void clearline(GtkWidget *w, gpointer callData)
#else
void clearline(Widget w, XtPointer clientData, XtPointer callData)
#endif
{
  int i;

  for (i=1; i<=NoOfElements; i++) 
    atoms[i] = 0;

  strcpy(inputstr, "");
#ifdef GTK
  gtk_entry_set_text(GTK_ENTRY(inputline), inputstr);
  gtk_clist_clear(GTK_CLIST(resultwin));
#else
  XmTextFieldSetString(inputline, inputstr);
  XtVaSetValues(resultwin, XmNitems, NULL, XmNitemCount, 0, NULL);
#endif
  for(i=0; i<NoOfToken; i++)
    strcpy(token[i], "");

#ifdef GTK
  gtk_entry_set_text(GTK_ENTRY(weightwin), "");
#else
  XmTextFieldSetString(weightwin, "");
#endif

#ifdef GTK
  gtk_widget_grab_focus(inputline);
#else
  XmProcessTraversal(inputline, XmTRAVERSE_CURRENT);
#endif
}

#ifdef GTK
void endofprogram(GtkWidget *w, gpointer callData)
#else
void endofprogram(Widget w, XtPointer clientData, XtPointer callData)
#endif
{
  exit(0);
}
