/*
  $Id: molwt.c,v 1.3 2001/03/12 13:22:43 rmiya Exp $

  Calculate Molecular Weight and 
    Elemental Analysis
    which works on X11

  copyright (c) by Ryo MIYAMOTO, 1998-1999
*/

#include "molwt.h"

int main(int argc, char* argv[])
{
#ifdef GTK
  if (strcmp(argv[0]+strlen(argv[0])-6, "gmolwt")==0) {
#else
  if (strcmp(argv[0]+strlen(argv[0])-6, "xmolwt")==0) {
#endif
    isGUI=TRUE;
    main1(argc, argv);
  } else if (strcmp(argv[0]+strlen(argv[0])-5, "molwt")==0) {
    isGUI=FALSE;
    main2(argc, argv);
  } else {
    isGUI=TRUE;
    main1(argc, argv);
  }

  return 0;
}

int main1(int argc, char* argv[])
{
#ifdef GTK
  /*gtk_set_locale();*/
  gtk_init(&argc, &argv);
  /*gtk_rc_parse("./gtkrc");*/

  toplevel=gtk_window_new(GTK_WINDOW_TOPLEVEL); 
  gtk_widget_set_name(toplevel, "Molwt");
#else
  XtAppContext app_context;

  XtSetLanguageProc(NULL, NULL, NULL);

  toplevel=XtAppInitialize(&app_context, "Xmolwt", NULL, 0, 
                           &argc, argv, NULL, NULL, 0);
#endif

  initwidget();
  elements();

#ifdef GTK
  gtk_main();
#else
  XtAppMainLoop(app_context);
#endif
  exit(0);
}

int main2(int argc, char* argv[])
{
  int i;
  char str[BUFSIZ];

  if (argc==1) {
    errorDialog(isGUI);
  } else if (argc==2) {
    strncpy(str, argv[1], BUFSIZ-1);
/*    fprintf(stderr, ":%s:\n", str);*/
  } else {
    errorDialog(isGUI);
  }

  elements(); 
  Symbol2=FALSE;

  for (i=1; i<=NoOfElements; i++) 
    atoms[i] = 0;

  ntoken = reduce(token, str);
  count(atoms, token, ntoken);
  calculate2();

  exit(0);
}
