/*
  $Id: molwt.h,v 1.4 2001/03/12 13:22:44 rmiya Exp $

  Calculate Molecular Weight and 
    Elemental Analysis

  version 0.1 (1998)
  version 0.2 (1999)
  version 0.3 (1999) GTK+ version, merged
  version 0.4 (2001) update, brakets `()' in chemical formula

  copyright (c) by Ryo MIYAMOTO, 1998-1999

  Specifications:
    source code free
    command line / unix version
    (GUI, X version)

  Usage (command line):
    molwt <chemical formula>
  for example, 
    molwt C2H5OH

  Usage (X version, Motif):
    xmolwt

  Usage (X version, GTK+ version):
    gmolwt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#ifdef GTK
  #include <gtk/gtk.h>
#else
  #include <Xm/XmAll.h>
#endif

#define NoOfElements 109
#ifndef FALSE
#define FALSE (0)
#define TRUE (1)
#endif
#define NoOfToken 100
#define TokenLength 10

#ifdef GTK
typedef gboolean Boolean;
#endif

#ifdef GTK
GtkWidget *toplevel;
GtkWidget *panel, *labelformula, *inputline; 
GtkWidget *casebutton;
GtkWidget *calcbutton, *clearbutton, *endbutton, *buttons; 
GtkWidget *labelweight, *weightwin;
GtkWidget *labelcontents, *resultwin;
GtkWidget *dialog;
#else
Widget toplevel;
Widget bb, panel, labelformula, inputline; 
Widget casebutton, labelcase;
Widget calcbutton, clearbutton, endbutton, buttons; 
Widget labelweight, weightwin;
Widget labelcontents, resultwin;
Widget dialog;
#endif
Boolean Symbol2;

#ifdef GTK
void allowcase(GtkWidget *, gpointer);
void inputformula(GtkWidget *, gpointer);
void calculateCB(GtkWidget *, gpointer);
void clearline(GtkWidget *, gpointer);
void endofprogram(GtkWidget *, gpointer);
#else
void allowcase(Widget, XtPointer, XtPointer);
void inputformula(Widget, XtPointer, XtPointer);
void calculateCB(Widget, XtPointer, XtPointer);
void clearline(Widget, XtPointer, XtPointer);
void endofprogram(Widget, XtPointer, XtPointer);
#endif
int initwidget(void);
void addtolist(float *, char token[NoOfToken][TokenLength], int);
void errorDialog();
int atomicnumber(char *, Boolean, int *);

int main1(int argc, char* argv[]);
int main2(int argc, char* argv[]);
void elements(void);
int usage(void);
int reduce(char token[NoOfToken][TokenLength], char *);
int count(float *, char token[NoOfToken][TokenLength], int);
void reduce2(char token[NoOfToken][TokenLength], int *ntoken);
void calculate2(void);

char inputstr[BUFSIZ];
int ntoken;
char token[NoOfToken][TokenLength];
float atoms[NoOfElements+1];
double FormulaWeight;
Boolean isGUI;

struct Element {
  int AtomNo;
  double Weight;
  char* Symbol;
  char* Symbol2;
  char* Name;
} element[NoOfElements+1];

