/*
  $Id: reduce.c,v 1.3 2001/03/12 07:24:09 rmiya Exp $

  Calculate Molecular Weight and 
    Elemental Analysis

  copyright (c) by Ryo MIYAMOTO, 1998-1999
*/

#include "molwt.h"

int reduce(char token[NoOfToken][TokenLength], char *str)
{
  int len, idx, i, j;

  ntoken = 0;
  len = strlen(str);
/*fprintf(stderr, "length = %d\n", len);*/

  /* delimiter is: alpha->num, num->alpha, space, */
  /* element symbol */
  for (idx=0; idx<len; idx++) {
    if (isalpha(str[idx])) {
      i=0;
      while (isalpha(str[idx])) {
	token[ntoken][i++]=str[idx++];
      }
      token[ntoken][i]='\0';
/*      fprintf(stderr, "alpha:%s:\n", token[ntoken]);*/
      --idx;

      reduce2(token, &ntoken);
      ntoken++;

    } else if (isdigit(str[idx]) || str[idx]=='.') {
      i=0;
      while (isdigit(str[idx]) || str[idx]=='.') {
	token[ntoken][i++]=str[idx++];
      }
      token[ntoken][i]='\0';
/*    fprintf(stderr, "digit:%s:\n", token[ntoken]);*/
      ntoken++;
      --idx;

    } else if (str[idx]=='(' || str[idx]==')') {
      token[ntoken][0]=str[idx++];
      token[ntoken][1]='\0';
/*    fprintf(stderr, "braket:%s:\n", token[ntoken]);*/
      ntoken++;
      --idx;
    } else if (isspace(str[idx])) {
      while (isspace(str[idx]))
	idx++;
      idx-=1;
/*    fprintf(stderr, "space::\n");*/
    } else {
/*    fprintf(stderr, "anythig else: what ?!\n");*/
    }
  };

  for (i=0; i<ntoken; i++) {
    if ((isalpha(token[i][0]) || token[i][0] == ')') &&
        (!isdigit(token[i+1][0]) && token[i+1][0]!='.')){
/*      fprintf(stderr, "<%d>%s[Y] \n", i, token[i]);*/
      for(j=ntoken; j>=i+2; j--)
        strcpy(token[j], token[j-1]);
      strcpy(token[i+1], "1");
      ntoken++;
    } else {
/*      fprintf(stderr, "<%d>%s[N] \n", i, token[i]);*/
    }
  }
/*  fprintf(stderr, "ntoken = %d\n", ntoken);*/

/*  for (i=0; i<ntoken; i++)
    fprintf(stderr, "%s:", token[i]);
  fputs("\n", stderr);*/

  return (ntoken);
}

void reduce2(char token[NoOfToken][TokenLength], int *ntoken)
{
  char str[BUFSIZ];
  int n, len, slen, slen2;
  Boolean isFound;

  strcpy(str, token[*ntoken]);
/*fprintf(stderr, "Here is reduce2, token is %d:%s:\n", *ntoken, str);*/

  len=strlen(str);
  if (len==0) {
    --(*ntoken);
    return;
  }

  isFound=FALSE;
  for(n=1; n<=NoOfElements; n++) {
    slen=strlen(element[n].Symbol);
    slen2=strlen(element[n].Symbol2);
    if (strncmp(str, element[n].Symbol, slen)==0) {
      isFound=TRUE;
/*      fprintf(stderr, "Found (%s)==(%s)\n", str, element[n].Symbol);*/
      strcpy(token[*ntoken+1], str+slen);
      token[*ntoken][slen]='\0';
      (*ntoken)++;
      break;
    } else if (Symbol2==TRUE && strncmp(str, element[n].Symbol2, slen2)==0) {
      isFound=TRUE;
      strcpy(token[*ntoken+1], str+slen2);
      token[*ntoken][slen2]='\0';
      (*ntoken)++;
      break;
    }
  }
  if (isFound==FALSE) {
/*fprintf(stderr, "Not found [%s]\n", str);*/
    strncpy(token[*ntoken+1], str+1, len-1);
    token[*ntoken][1]='\0';
    (*ntoken)++;
  }

  reduce2(token, ntoken);

}
